# coding: utf-8

"""
    DeviceServer

    DeviceServer API  # noqa: E501

    The version of the OpenAPI document: 1.0.4
    Contact: david@3adesign.co.uk
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from DeviceServer.configuration import Configuration


class DeviceTemperaturePort(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'temperature_port_index': 'int',
        'label': 'str',
        'temperature_port_id': 'str',
        'value': 'float'
    }

    attribute_map = {
        'temperature_port_index': 'temperature_port_index',
        'label': 'label',
        'temperature_port_id': 'temperature_port_id',
        'value': 'value'
    }

    def __init__(self, temperature_port_index=None, label=None, temperature_port_id=None, value=None, local_vars_configuration=None):  # noqa: E501
        """DeviceTemperaturePort - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._temperature_port_index = None
        self._label = None
        self._temperature_port_id = None
        self._value = None
        self.discriminator = None

        self.temperature_port_index = temperature_port_index
        if label is not None:
            self.label = label
        self.temperature_port_id = temperature_port_id
        if value is not None:
            self.value = value

    @property
    def temperature_port_index(self):
        """Gets the temperature_port_index of this DeviceTemperaturePort.  # noqa: E501


        :return: The temperature_port_index of this DeviceTemperaturePort.  # noqa: E501
        :rtype: int
        """
        return self._temperature_port_index

    @temperature_port_index.setter
    def temperature_port_index(self, temperature_port_index):
        """Sets the temperature_port_index of this DeviceTemperaturePort.


        :param temperature_port_index: The temperature_port_index of this DeviceTemperaturePort.  # noqa: E501
        :type temperature_port_index: int
        """
        if self.local_vars_configuration.client_side_validation and temperature_port_index is None:  # noqa: E501
            raise ValueError("Invalid value for `temperature_port_index`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                temperature_port_index is not None and temperature_port_index > 100):  # noqa: E501
            raise ValueError("Invalid value for `temperature_port_index`, must be a value less than or equal to `100`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                temperature_port_index is not None and temperature_port_index < 1):  # noqa: E501
            raise ValueError("Invalid value for `temperature_port_index`, must be a value greater than or equal to `1`")  # noqa: E501

        self._temperature_port_index = temperature_port_index

    @property
    def label(self):
        """Gets the label of this DeviceTemperaturePort.  # noqa: E501


        :return: The label of this DeviceTemperaturePort.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this DeviceTemperaturePort.


        :param label: The label of this DeviceTemperaturePort.  # noqa: E501
        :type label: str
        """
        if (self.local_vars_configuration.client_side_validation and
                label is not None and len(label) > 64):
            raise ValueError("Invalid value for `label`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                label is not None and len(label) < 1):
            raise ValueError("Invalid value for `label`, length must be greater than or equal to `1`")  # noqa: E501

        self._label = label

    @property
    def temperature_port_id(self):
        """Gets the temperature_port_id of this DeviceTemperaturePort.  # noqa: E501


        :return: The temperature_port_id of this DeviceTemperaturePort.  # noqa: E501
        :rtype: str
        """
        return self._temperature_port_id

    @temperature_port_id.setter
    def temperature_port_id(self, temperature_port_id):
        """Sets the temperature_port_id of this DeviceTemperaturePort.


        :param temperature_port_id: The temperature_port_id of this DeviceTemperaturePort.  # noqa: E501
        :type temperature_port_id: str
        """
        if self.local_vars_configuration.client_side_validation and temperature_port_id is None:  # noqa: E501
            raise ValueError("Invalid value for `temperature_port_id`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                temperature_port_id is not None and len(temperature_port_id) > 36):
            raise ValueError("Invalid value for `temperature_port_id`, length must be less than or equal to `36`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                temperature_port_id is not None and len(temperature_port_id) < 36):
            raise ValueError("Invalid value for `temperature_port_id`, length must be greater than or equal to `36`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                temperature_port_id is not None and not re.search(r'[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}', temperature_port_id)):  # noqa: E501
            raise ValueError(r"Invalid value for `temperature_port_id`, must be a follow pattern or equal to `/[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}/`")  # noqa: E501

        self._temperature_port_id = temperature_port_id

    @property
    def value(self):
        """Gets the value of this DeviceTemperaturePort.  # noqa: E501


        :return: The value of this DeviceTemperaturePort.  # noqa: E501
        :rtype: float
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this DeviceTemperaturePort.


        :param value: The value of this DeviceTemperaturePort.  # noqa: E501
        :type value: float
        """
        if (self.local_vars_configuration.client_side_validation and
                value is not None and value > 1000):  # noqa: E501
            raise ValueError("Invalid value for `value`, must be a value less than or equal to `1000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                value is not None and value < -1000):  # noqa: E501
            raise ValueError("Invalid value for `value`, must be a value greater than or equal to `-1000`")  # noqa: E501

        self._value = value

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeviceTemperaturePort):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DeviceTemperaturePort):
            return True

        return self.to_dict() != other.to_dict()
